﻿function resize(element) {
    if (element != null) {
        var w = 0, xContent, canvas, chart;

        if (element instanceof HTMLCanvasElement) {
            canvas = element;

            if (canvas.chart instanceof Tee.Chart) {
                chart = canvas.chart;

                hostChart = canvas.chart;

                if (element.offsetParent != null)
                    w = element.offsetParent.clientWidth - 280;
                else {
                    xContent = $(canvas).closest('.tabcontent')[0];
                    w = xContent.parentElement.offsetWidth * 0.95;
                }

                canvas.width = w;
                chart.bounds.width = w - 30;
                chart.draw();
            }
        }
    }
}

function resizeC(chart) {
    resize(chart.ctx.canvas);
}

function resizeAll() {
    $('canvas').each(function () {
        resize(this);
    })
}

window.onresize = function () {
    resizeAll();
}

$(window).on('mousemove', function (evt) {

    if ((hostChart != undefined) && (hostChart.tools != undefined)) {

        var p = new Tee.Point(evt.clientX, evt.clientY);
        var overChart = -1;

        var tooltip = undefined;
        hostChart.tools.items.forEach(tool => {
            if (tool instanceof Tee.ToolTip)
                tooltip = tool;
        });

        if (tooltip != undefined) {

            tooltip.isDom = tooltip.render === "dom";

            var rect = hostChart.canvas.getBoundingClientRect();
            rect = new Tee.Rectangle(rect.x, rect.y, rect.width, rect.height);
            if (!rect.contains(p)) {
                if (!tooltip.isDom) {
                    tooltip.hide();
                }
            }
            else {
                if (tooltip.isDom) {
                    overChart = -1; // idx;
                    return true;
                }
            }

            if ((overChart == -1) && (tooltip !== undefined)) {
                tooltip.hide();
            }
        }
    }
});